<?php
namespace Woopromotion\Classes;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  *
  */
 
  if( ! defined( 'ABSPATH' ) ) {
      die( WOOPROMOTION_ALERT_MSG );
  }

class Canvas_Header {

  public function getCanvasHeader() {
    $this->canvasHeaderHtml();
  }

  public function getOption( $key ) {
    return \Woopromotion\Inc\Helper::getOption($key);
  }

  private function canvasHeaderHtml() {

    $position = $this->getOption('set_position');
    $bgColor   = $this->getOption('bg_color');
    $bgImage   = $this->getOption('bg_image');
    $textColor = $this->getOption('text_color');

    //
    $getBgColor = '';
    $getBgImage = '';
    $getTextColor = '';
    // Background color
    if( !empty( $bgColor ) ) {
      $getBgColor = 'background-color:'.esc_attr( $bgColor ).';';
    }
    // Background Image
    if( !empty( $bgImage ) ) {
      $getBgImage = 'background:url('.esc_attr( $bgImage ).');background-size: cover;background-position: center;';
    }

    // Text Color
    if( !empty( $textColor ) ) {
      $getTextColor = 'color:'.esc_attr( $textColor ).';';
    }
    //
    $styleAttr = '';
    if( !empty( $getBgColor ) || !empty( $getBgImage ) ) {
      $styleAttr = 'style="'.$getBgColor.$getBgImage.$getTextColor.'"';
    }

    $is_both = '';

    echo '<div class="canvas-header-wrapper '.esc_attr( 'position-'.$position ).'" '.$styleAttr.'>';

      // Canvas content
      if( !empty( $this->getOption('show_canvas_bar_content') ) ) {
        $is_both = 'mt-t25';
        echo '<div class="canvas-header-inner">'.$this->image().$this->text().$this->countDownTimer().$this->link().$this->cancle().'</div>';
      }

      // Ticker
      if( !empty( $this->getOption('active_ticker') ) ) {
        echo '<div class="canvas-header-ticker '.esc_attr( $is_both ).'">'.$this->getTicker().'</div>';
      }

    echo '</div>';

  }

  private function text() {
    $text = $this->getOption('promo_text');
    if( empty( $text ) ) {
      return;
    }
    $arr = array( 'br' => array(), 'p' => array(), 'span' => array(), 'a' => array( 'href' => array() ), 'strong' => array() );

    return '<div class="header-text">'.wp_kses( $text, $arr ).'</div>';
  }
  
  private function image() {
    $img = $this->getOption('promo_image');

    if( !empty( $img ) ) {
      return '<img src="'.esc_url($img).'" />';
    }
  }
  private function link() {
    $text = $this->getOption('button_text');
    $url = $this->getOption('button_url');
    if( !empty( $text ) ) {
      return '<a class="canvas-header-button" href="'.esc_url( $url ).'">'.esc_html( $text ).'</a>';
    }
    
  }
  private function cancle() {
    $textColor = $this->getOption('text_color');
    $getBorderColor = '';
    // Text Color
    if( !empty( $textColor ) ) {
      $getBorderColor = 'border-color:'.esc_attr( $textColor ).';';
    }
    //
    $styleAttr = '';
    if( !empty( $getBorderColor ) ) {
      $styleAttr = 'style="'.$getBorderColor.'"';
    }

    return '<span class="canvas-header-cancle" '.$styleAttr.'>X</span>';
  }
  private function countDownTimer() {
    $opt = $this->getOption('show_timer');
    if( empty($opt) ) {
      return;
    }

    $setDate = $this->getOption('set_date');
    $setTime = $this->getOption('set_time');
    //
    $setEndDate = $this->getOption('set_end_date');
    $setEndTime = $this->getOption('set_end_time');
    //
    $dateTime = $setDate.' '.$setTime;
    $endTime = $setEndDate.' '.$setEndTime;

    return \Woopromotion\Classes\Countdown_Timer::countdownTimer( $dateTime, $endTime, 'woopromotion-time-countdown' );

  }

  private function getTicker() {
    return \Woopromotion\Classes\Scroll_Ticker::getScrollTicker();
  }

}