<?php
namespace Woopromotion\Classes;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  *
  */
 
  if( ! defined( 'ABSPATH' ) ) {
      die( WOOPROMOTION_ALERT_MSG );
  }

class Scroll_Ticker {
  
  public static function getScrollTicker() {
    //
    return self::tickerHtml();
  } 

  private static function tickerHtml() {
      ob_start();
      $tickerText = \Woopromotion\Inc\Helper::getOption('ticker_text');
      $headerText = \Woopromotion\Inc\Helper::getOption('heading_text');
      $controls   = \Woopromotion\Inc\Helper::getOption('ticker_controls');
      //
      $headingBg   = \Woopromotion\Inc\Helper::getOption('heading_bg_color', '#4030bf');
      $headingText = \Woopromotion\Inc\Helper::getOption('heading_text_color', '#fff');
      //
      $tickerBg     = \Woopromotion\Inc\Helper::getOption('ticker_bg_color', '#fff');
      $tickerBorder = \Woopromotion\Inc\Helper::getOption('ticker_border_color', '#4030bf');
      $tickerTextColor   = \Woopromotion\Inc\Helper::getOption('ticker_text_color', '#000');
      //
      $tickerControlsBg = \Woopromotion\Inc\Helper::getOption('ticker_controls_bg_color', '#fff');
      $tickerControlsBorder = \Woopromotion\Inc\Helper::getOption('ticker_controls_border_color', '#eee');
     
      echo '<div class="acme-news-ticker" style="background-color:'.esc_html($tickerBg).';border-color:'.esc_html($tickerBorder).';color:'.esc_html($tickerTextColor).';">';
   
        if( !empty( $headerText ) ) {
          echo '<div class="acme-news-ticker-label" style="background-color:'.esc_html($headingBg).';color:'.esc_html($headingText).';">'.esc_html( $headerText ).'</div>';
        }
        ?>
        <div class="acme-news-ticker-box">
          <ul class="woopromo-news-ticker">
            <?php 
            if( !empty( $tickerText ) ) {
              $allowHtml = [
                'a' => [
                  'href' => [],
                  'target' => []
                ]
              ];
              foreach( $tickerText as $ticker ) {
                echo '<li>'.wp_kses( $ticker, $allowHtml ).'</li>';
              }
            }
            ?>
          </ul>
        </div>
        <?php 
        if( !empty( $controls ) ):
       
        echo '<div class="acme-news-ticker-controls acme-news-ticker-horizontal-controls">
          <span style="background-color:'.esc_html($tickerControlsBg).';border-color:'.esc_html($tickerControlsBorder).';" class="acme-news-ticker-arrow acme-news-ticker-prev"></span>
          <span style="background-color:'.esc_html($tickerControlsBg).';border-color:'.esc_html($tickerControlsBorder).';" style="background-color:'.esc_html($tickerControlsBg).';border-color:'.esc_html($tickerControlsBorder).';" class="acme-news-ticker-pause"></span>
          <span style="background-color:'.esc_html($tickerControlsBg).';border-color:'.esc_html($tickerControlsBorder).';" style="background-color:'.esc_html($tickerControlsBg).';border-color:'.esc_html($tickerControlsBorder).';" class="acme-news-ticker-arrow acme-news-ticker-next"></span>
        </div>';
      
        endif;
       
      echo '</div>';
    
      return ob_get_clean();

  }

}