<?php
namespace Woopromotion\Classes;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  *
  */
 
if( ! defined( 'ABSPATH' ) ) {
    die( WOOPROMOTION_ALERT_MSG );
}

class Stock_Progress_Bar extends Product_Data {

  public $totalSales;
  public $stockQuantity;

  function __construct() {
    
    // Call Product_Data constructor
    parent::__construct();

    $product = $this->getProduct;

    $this->totalSales = $product->get_total_sales();
    $this->stockQuantity = $product->get_stock_quantity();

  }

  public function soldProgressBar() {
    return $this->progressBarHtml();
  }

  private function stockSoldPercentage() {

    $totalSales = $this->totalSales;
    $stockQuantity = $this->stockQuantity;
    //
    if( empty( $stockQuantity ) && empty( $totalSales ) ) {
      return;
    }
    //
    $totalStock = $stockQuantity+$totalSales;

    $percentage  = ($totalStock  - $stockQuantity  ) / $totalStock * 100;
    return $percentage;
  }

  public function progressBarHtml() {

    $style = \Woopromotion\Inc\Helper::getOption('stock_progress_br_style');

    $addClass = 'shop-stock-bar';
    if( is_product() ) {
      $addClass = 'product-stock-bar';
    }

    return '<div class="stock-progress-wrapper '.esc_attr( $addClass.' '.$style ).'"><div><div class="stock-progress">
      <div class="stock-progress-bar" style="width:'.esc_attr( $this->stockSoldPercentage() ).'%"></div>
    </div><span>'.sprintf( esc_html__( '%s sold', 'woopromotion' ), $this->totalSales ).'</span></div></div>';
  }
  
}