<?php
namespace Woopromotion\Classes;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  *
  */
 
  if( ! defined( 'ABSPATH' ) ) {
      die( WOOPROMOTION_ALERT_MSG );
  }

class Woo_Hooks {

  function __construct() {

    add_filter( 'woocommerce_locate_template', [ __CLASS__, 'woo_templating' ], 1, 3 );
    add_action( 'woocommerce_before_shop_loop_item_title', [ __CLASS__, 'add_products_badges' ] );
    add_action( 'woocommerce_single_product_summary', [ __CLASS__, 'product_sold_progress_bar_before_addtocart' ], 25 );
    add_action( 'woocommerce_single_product_summary', [ __CLASS__, 'add_products_badges' ], 22 );
    add_action( 'woocommerce_after_shop_loop_item', [ __CLASS__, 'shop_stock_progressbar' ], 5 ); 
    add_action( 'woocommerce_single_product_summary', [ __CLASS__, 'product_flash_sale_details' ], 1 );
    add_action( 'wp_footer', [ __CLASS__, 'product_loop_down_price_arrow' ] );
    add_filter('woocommerce_sale_flash', [__CLASS__, 'product_sale_flash_in_percentage'], 11, 3);
    add_filter( 'woocommerce_add_to_cart_fragments', [ __CLASS__, 'cart_fragments' ], 10, 1 );
    add_action( 'woocommerce_checkout_before_order_review', [ __CLASS__, 'checkout_before_order_review' ], 10, 0 );

  }
  /**
   * [getOption description]
   * @param  [type] $key [description]
   * @return [type]      [description]
   */
  public static function getOption( $key ) {
    return \Woopromotion\Inc\Helper::getOption($key);
  }
  /**
   * [add_top_rated_badge description]
   */
  public static function add_products_badges() {
    if( !empty( self::getOption('show_badges') ) ) {
      \Woopromotion\Classes\Badge_Manager::getBadges();
    }

  }
  /**
   * product_sold_progress_bar_before_addtocart
   * Show sale progress bar before add to cart button in product page
   * 
   * @return void
   */
  public static function product_sold_progress_bar_before_addtocart() {
    //
    if( !empty( self::getOption('product_stock_progress_bar_show') ) ) {
      $obj = new \Woopromotion\Classes\Stock_Progress_Bar();
      echo $obj->soldProgressBar();
    }
    // Product sale count
    if( !empty( self::getOption('product_day_sale_count_show') ) ) {
      $psc = new \Woopromotion\Classes\Sold_Count_On_Date();
      $psc->getProductSoldCount();
    }
  }


  /**
   * [shop_stock_progressbar description]
   * @return [type] [description]
   */
  public static function shop_stock_progressbar() {

    // Shop product stock progress bar 
    if( !empty( self::getOption('stock_progress_bar_show') ) ) {
      $obj = new \Woopromotion\Classes\Stock_Progress_Bar();
      echo $obj->soldProgressBar();
    }
    // Product sale count
    if( !empty( self::getOption('product_day_sale_count_show') ) ) {
      $psc = new \Woopromotion\Classes\Sold_Count_On_Date();
      $psc->getProductSoldCount();
    }
    // Shop Page product flash sale countdown
    if( !empty( self::getOption('shop_product_flash_countdown') ) ) {
      $countDown = new \Woopromotion\Classes\Flash_Sale_Countdown();
      $countDown->countdown();
    }
    
  }
  
  /**
   * [product_flash_sale_details description]
   * @return [type] [description]
   */
  public static function product_flash_sale_details() {

    if( !empty( self::getOption( 'product_flash_details_bar' ) ) ) {
      $obj = new \Woopromotion\Classes\Product_Flash_Sale_Details();
      $obj->flashSaleDetails();
    }
  }

  /**
   * [product_loop_down_price_arrow description]
   * @return [type] [description]
   */
  public static function product_loop_down_price_arrow() {

    if( is_product() && !empty( self::getOption('product_discount_percentage_badge') ) ) {
      $obj = new \Woopromotion\Classes\Price_Down_Badge();
  ?>
    <script type="text/javascript">
      (function($) {
        $('.summary.entry-summary p.price').prepend('<?php echo $obj->priceDownbadge() ?>');
      })( jQuery )
    
    </script>
  <?php
    }
  }


/**
 * [woo_templating description]
 * Override WooCommerce Templates
 * @param  [type] $template      [description]
 * @param  [type] $template_name [description]
 * @param  [type] $template_path [description]
 * @return void                [description]
 */
public static function woo_templating( $template, $template_name, $template_path ) {

     global $woocommerce;
     $_template = $template;
     if ( ! $template_path ) 
        $template_path = $woocommerce->template_url;
 
     $plugin_path  = untrailingslashit( WOOPROMOTION_DIR_PATH )  . '/woocommerce/templates/';
 
    // Look within passed path within the theme - this is priority
    $template = locate_template(
      array(
        $template_path . $template_name,
        $template_name
      )
   );
 
  if( file_exists( $plugin_path . $template_name ) ) {
    $template = $plugin_path . $template_name;
  }
  //
  if ( ! $template ) {
    $template = $_template;
  }

  return $template;

}
/**
 * [product_sale_flash_in_percentage description]
 * @param  [type] $output  [description]
 * @param  [type] $post    [description]
 * @param  [type] $product [description]
 * @return [type]          [description]
 */
public static function product_sale_flash_in_percentage($output, $post, $product) {

      if (!empty( self::getOption('product_sale_flash_percentage') )) {
          global $product;
          if ($product->is_on_sale()) {
              if ($product->is_type('variable')) {
                  $regular_price = $product->get_variation_regular_price();
                  $sale_price = $product->get_variation_price();
              } else {
                  $regular_price = $product->get_regular_price();
                  $sale_price = $product->get_sale_price();
              }

              if (!empty($sale_price)) {
                  $percent_off = (($regular_price - $sale_price) / $regular_price) * 100;
                  return '<span class="onsale">' . round($percent_off) . __('% Off', 'woopromotion') . '</span>';

              } else {
                  return $output;
              }

          }
      } else {
          return $output;
      }


  }

/**
 * Set a minimum order amount for checkout
 * @return [type] [description]
 */
public static function cart_fragments( $fragments ) {

  $option = get_option('woopromotion_options');

  ob_start();

    $cartCount = WC()->cart->get_cart_contents_count();
    $cartSubtotal = WC()->cart->get_cart_subtotal();
    $free_shipping_order_amount = !empty( $option['free_shipping_order_amount'] ) ? $option['free_shipping_order_amount'] : '';
    $cartSubtotalWithoutCurrency = WC()->cart->cart_contents_total;
    // Free shipping order amount progress Percentage
    $freeShipProgressPercentageCal =  ( $free_shipping_order_amount - $cartSubtotalWithoutCurrency   ) / $free_shipping_order_amount * 100;
    $freeShipProgress = 100 - $freeShipProgressPercentageCal;
    
    //
    $wiggleAnimation = !empty( $option['active_wiggle_animation'] ) ? 'wiggle-animation' : '';
    $bgclipAnimation = !empty( $option['active_bgclip_animation'] ) ? 'text-bgclip-animation' : '';

    // Text
    $checkoutLink = '<a href="'.wc_get_checkout_url().'" target="_blank">'.esc_html__( 'Checkout', 'woopromotion' ).'</a>';
    $congDefaultText = sprintf( esc_html__( "Congratulations! you have got free shipping. Go to %s.", "woopromotion" ), $checkoutLink );
    $congratulationsText = !empty( $option['success_text'] ) ? str_replace( '{checkout_url}', $checkoutLink, $option['success_text'] ) : $congDefaultText;
    // Announce Text
    $freeShippingOrderAmount = \Woopromotion\Inc\Helper::woo_currency_symbol_position( $free_shipping_order_amount );
    $announceText = sprintf( esc_html__( "Get Free shipping for billing over %s.", "woopromotion" ), '<span class="'.esc_attr( $wiggleAnimation ).'">'.$freeShippingOrderAmount.'</span>' );
    $getAnnounceText = !empty( $option['announce_text'] ) ? str_replace( '{free_shipping_amount}', $freeShippingOrderAmount, $option['announce_text'] ) : $announceText;
    //
    $purchasedDefaultText = sprintf( esc_html__( 'You have purchased %s of %s To get free shipping', 'woopromotion' ), $cartSubtotal, '<span class="'.esc_attr( $wiggleAnimation ).'">'.$freeShippingOrderAmount.'</span>' );

    $purchasedText = !empty( $option['purchased_text'] ) ? str_replace( ['{free_shipping_amount}', '{total_cart_amount}'], [ $freeShippingOrderAmount, $cartSubtotal ], $option['purchased_text'] ) : $purchasedDefaultText;

    ?>
    <div class="floating-canvas-inner-top">
    <?php 
    if( !empty( $option['show_order_free_shipping_amount_progress_info'] ) ):
    ?>
    <div class="cart-progress-bar" style="background:#bbbbbb;height:8px;width:100%">
      <div style="background:#ff00b1;height:8px;width:<?php echo esc_attr( $freeShipProgress ); ?>%"></div>
    </div>
    <?php 
    endif;
    ?>
    <div class="floating-canvas-inner">
      <div class="floating-canvas-cart-info-total">
        <?php 
          if( !empty( $option['show_mini_cart_info'] ) ) {
            echo esc_html( 'Cart Items '.$cartCount, 'woopromotion' ); 
          }
        ?> 
        <div class="minimum-order-amount-offer"> 
          <?php 
          if( !empty( $option['show_order_free_shipping_amount_progress_info'] ) ) {
            if( !empty( $cartSubtotalWithoutCurrency ) ) {
              if( $cartSubtotalWithoutCurrency > $free_shipping_order_amount ) {
                echo '<p class="'.esc_attr( $bgclipAnimation ).'">'.apply_filters( 'woopromotion_congratulations_text', $congratulationsText ).'</p>';
              } else {
                echo '<p>'.apply_filters( 'woopromotion_purchased_text', $purchasedText ).'</p>';
              }
              
            } else {
              echo '<p>'.apply_filters( 'woopromotion_announce_text', $getAnnounceText ).'</p>';
            }
          }
          ?>
        </div>
        <?php
        if( !empty( $option['show_mini_cart_info'] )  ) {
          echo '<span class="canvas-cart-total">'.esc_html( 'Cart Total:', 'woopromotion' ).' '.$cartSubtotal.'</span>';
        }
        ?>
        <span class="hide-floating-canvas-cart-progress">X</span>
      </div>
    </div>
    </div>
    <?php
        $fragments['.floating-canvas-inner-top'] = ob_get_clean();
    return $fragments;
    
}

/**
 * define the woocommerce_checkout_before_order_review callback 
 * @return [type] [description]
 */
public static function checkout_before_order_review() {
  $option = get_option('woopromotion_options');
  $cartSubtotal = WC()->cart->cart_contents_total;
  $free_shipping_order_amount = !empty( $option['free_shipping_order_amount'] ) ? $option['free_shipping_order_amount'] : 0;

  //
  if( $free_shipping_order_amount > $cartSubtotal ) {

    $missingAmount = $free_shipping_order_amount - $cartSubtotal;
    $missingAmount = \Woopromotion\Inc\Helper::woo_currency_symbol_position( $missingAmount );
    $missingText = sprintf( esc_html__( "You are missing %s to get free shipping.Continue shopping.", "woopromotion" ), $missingAmount );
    $getMissingText = !empty( $option['missing_text'] ) ? str_replace( '{missing_amount}', $missingAmount, $option['missing_text'] ) : $missingText;

    echo '<div class="offer-missing-info"><p>'.$getMissingText.'</p></div>';

  }
  

}



} // Class End