<?php
namespace Woopromotion\Classes;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  *
  */
 
  if( ! defined( 'ABSPATH' ) ) {
      die( WOOPROMOTION_ALERT_MSG );
  }


class Woo_Product_Tab {

	function __construct() {

		add_filter( 'woocommerce_product_data_tabs', [ $this, 'product_data_tab' ] );
		add_action('woocommerce_product_data_panels', [ $this, 'product_tab_fields' ] );
		add_action( 'woocommerce_process_product_meta', [ $this, 'save_data_custom_fields' ]  );
	}


	// Tab by hooking into the 'woocommerce_product_data_tabs' filter
	public function product_data_tab( $product_tabs ) {

	    $product_tabs['woopromotion-custom-tab-badges'] = array(
	        'label' 	=> esc_html__( 'Badges Manage', 'woopromotion' ),
	        'target' 	=> 'woopromotion_custom_product_badges_data',
	        'class'   => array( 'show_if_simple', 'show_if_variable' ),
	    );

	    return $product_tabs;
	}

	// functions you can call to output text boxes, select boxes, etc.
	public function product_tab_fields() {

	    global $thepostid, $post;

	    $data = get_post_meta( $thepostid, '_woopromotion_product_badge', true );

	    $args = array(
	    	'numberposts' => -1,
	    	'meta_key'         => 'woopromotion_badge_type',
        'meta_value'       => 'by_product',
			  'post_type'   => 'woopromotion_badges'
			);

	    $getBadges = get_posts( $args );

	    ?> 
	    <div id="woopromotion_custom_product_badges_data" class="panel woocommerce_options_panel">
	    	<div class="options_group show_if_simple show_if_variable">
	    		<p class="form-field _sold_individually_field show_if_simple show_if_variable">
			    	<label for="_sold_individually"><?php esc_html_e( 'Select Badges', 'woopromotion' ); ?></label>
			    	<select class="woopromotion-multiselect" name="woopromotion_product_badge[]" multiple>
			    		<option value=""><?php esc_html_e( 'Select Badge', 'woopromotion' ); ?></option>
			    		<?php 
			    		foreach( $getBadges as $badge ) {
			    			$selected = ( is_array( $data ) && in_array( $badge->ID, $data ) ) ? 'selected' : '';
			    			echo '<option value="'.esc_attr( $badge->ID ).'" '.esc_attr( $selected ).'>'.esc_html( $badge->post_title ).'</option>';
			    		}
			    		?>
			    	</select>
		    	</p>
	    	</div>
	    </div>

	    <?php

	}

	/** Hook callback function to save custom fields information */
	public function save_data_custom_fields( $post_id ) {
	    
	    // Save Text Field
	    if (!empty( $_POST['woopromotion_product_badge'] )) {
	    	$productBadge = $_POST['woopromotion_product_badge'];
	    } else {
	    	$productBadge = '';
	    }
	    update_post_meta ( $post_id, '_woopromotion_product_badge', $productBadge );
	}

}
