<?php
namespace Woopromotion\Inc;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  * 
  *
  */
 
if( ! defined( 'ABSPATH' ) ) {
    die( WOOPROMOTION_ALERT_MSG );
}

class Coupon_Code_Card_Shortcode {
  
  private $atts;

  function __construct( $atts ) {
    $this->atts = $atts;
  }

  private function cardId() {
    $attr = $this->atts;
    return $attr['card_id'];
  }
  private function cardData() {

    $cardId = $this->cardId();
    $metaPrefix = 'woopromotion_';

    $metaList = [
      'card_title',
      'offer_value',
      'offer_type',
      'coupon_description',
      'button',
      'coupon_code'
    ];

    $metaValue = [];

    foreach( $metaList as $list ) {
      $metaValue[$list] = get_post_meta( $cardId, $metaPrefix.$list, true );
    }

    return $metaValue;
  }
  private function cardStyleData() {
    $cardId = $this->cardId();
    $metaPrefix = 'woopromotion_';

    $metaList = [
      'card_bg_color',
      'title_color',
      'discount_wrapper_bg_color', 
      'discount_text_color', 
      'description_color', 
      'button_area_bg_color', 
      'button_bg_color', 
      'button_text_color', 
      'button_hover_bg_color', 
      'button_hover_text_color',
    ];

    $metaValue = [];

    foreach( $metaList as $list ) {
      $metaValue[$list] = get_post_meta( $cardId, $metaPrefix.$list, true );
    }

    return $metaValue;
  }
  public function get_card_id() {
    return $this->cardId();
  }
  public function get_card_data() {
    return $this->cardData();
  }
  public function get_card_style_data() {
    return $this->cardStyleData();
  }
  public function getCard() {
    $cardId = $this->cardId();
    $data = $this->get_card_data();
    $styleData = $this->get_card_style_data();

    $cardClass = 'coupon-card-'.esc_attr( $cardId );

    // Style
    if( !empty( array_filter($styleData) ) ) {

        $wrapperBg = $styleData['card_bg_color'];
        $title     = $styleData['title_color'];
        $DiscountWrapperBgColor = $styleData['discount_wrapper_bg_color'];
        $discountTextColor      = $styleData['discount_text_color'];
        $descriptionTextColor = $styleData['description_color'];
        $buttonAreaBgColor    = $styleData['button_area_bg_color'];
        $buttonBgColor   = $styleData['button_bg_color'];
        $buttonTextColor = $styleData['button_text_color'];
        $buttonHoverBgColor   = $styleData['button_hover_bg_color'];
        $buttonHoverTextColor = $styleData['button_hover_text_color'];

        echo "<style>
            .$cardClass.woopromotion-coupon-card-wrapper {
                background-color: $wrapperBg;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .coupon-card-title h2 {
                color: $title;
            }
            .$cardClass .woopromotion-coupon-card-discount {
                background-color: $DiscountWrapperBgColor;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .discount.woopromotion-coupon-card-discount:after {
                border-top-color: $DiscountWrapperBgColor;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .discount {
                color: $discountTextColor;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .coupon-card-description {
                color: $descriptionTextColor;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .coupon.bg-color-blue {
                background-color: $buttonAreaBgColor;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .coupon.bg-color-blue {
                background-color: $buttonAreaBgColor;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .btn-code {
                background-color: $buttonBgColor;
                color: $buttonTextColor;
            }
            .$cardClass.woopromotion-coupon-card-wrapper .btn-code:hover {
                background-color: $buttonHoverBgColor;
                color: $buttonHoverTextColor;
            }
        </style>";
    }
    ?>
    
    <div class="<?php echo esc_attr( $cardClass ); ?> woopromotion-coupon-card-wrapper">
        <?php
        //
        if( !empty( $data['card_title'] ) ) {
            echo '<div class="coupon-card-title"><h2>'.esc_html( $data['card_title'] ).'</h2></div>';
        }
        ?>
        <div class="discount woopromotion-coupon-card-discount">
            <?php
            // 
            if( !empty( $data['offer_value'] ) ) {
               echo '<span>'.esc_html( $data['offer_value'] ).'</span>'; 
            }
            //
            if( !empty( $data['offer_type'] ) ) {
                echo '<div class="type">'.esc_html( $data['offer_type'] ).'</div>';
            }
            ?>
        </div>
        <?php
        //
        if( !empty( $data['coupon_description'] ) ) {
            echo '<div class="coupon-card-description">'.wp_kses( $data['coupon_description'], 'post' ).'</div>';
        }
        ?>
        <div class="coupon bg-color-blue">
            <?php
            // Button
            if( !empty( $data['button'] ) ) {
                echo '<button class="btn-code open-code">'.esc_html( $data['button'] ).'</button>';
            }
            //
            if( !empty( $data['coupon_code'] ) ) {
                echo '<div class="coupon-code">'.esc_html( $data['coupon_code'] ).'</div>';
            }
            ?>
        </div>
    </div>
    <?php
  }

}