<?php 
namespace Woopromotion\Meta;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  * 
  *
  */
 
  if( ! defined( 'ABSPATH' ) ) {
      die( WOOPROMOTION_ALERT_MSG );
  }


class Meta_Config {

	// Prefix
	public $prefix = 'woopromotion_';

	function __construct() {
		$this->badgesMetaField();
	}

	// Metabox fields object  Blood Request
	public function metabox_field_obj(){
		return $obj = new \Woopromotion\Meta\Main_MetaBox();
	}

	/**
	 *  Meta field for badges post type
	 * 
	 */
	public function badgesMetaField() {

		/**
		 *  Meta Field for woopromotion_badges
		 *  
		 */

		// Init meta object
		$obj = $this->metabox_field_obj();

		// Meta Box Create
		$obj->SetMetaBox = array(
			'uniq_id' 	=> 'woopromotion_badge_meta_field',
			'title' 	=> esc_html__( 'Badge Settings', 'woopromotion'),
			'type' 		=> array( 'woopromotion_badges' ),
			'context' =>  'normal',
			'priority' => 'high'
		);

		// Meta Fields
		$obj->SetMetaFields = array(

			array(
				'type' 	=> 'select',
				'id' 	=> $this->prefix.'badge_type',
				'label' => esc_html__( 'Badge Type', 'woopromotion' ),
				'options' => array(
					'by_product' 	=> esc_html__( 'Assign By Product', 'woopromotion' ),
					'category' 		=> esc_html__( 'Based On Category', 'woopromotion' ),
					'rating' 			=> esc_html__( 'Based On Rating', 'woopromotion' ),
					'featured'		=> esc_html__( 'Based On Product Featured', 'woopromotion' ),
					'sales' 			=> esc_html__( 'Based On Sales Count', 'woopromotion' ),
					'stock' 			=> esc_html__( 'Based On Stock', 'woopromotion' ),
					'sales_rating' 			=> esc_html__( 'Based On Sales and Rating', 'woopromotion' )
				)
			),

			array(
				'type' 	=> 'select',
				'id' 	=> $this->prefix.'product_category',
				'label' => esc_html__( 'Product Category', 'woopromotion' ),
				'class' => 'product-category',
				'options' => \Woopromotion\Inc\Helper::getProductCategories()
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'minimum_reviews',
				'class' => 'minimum-reviews',
				'label' => esc_html__( 'Minimum Reviews Required', 'woopromotion' ),
			),
			array(
				'type' 	=> 'select',
				'id' 	=> $this->prefix.'product_max_rating',
				'class' => 'product-max-rating',
				'label' => esc_html__( 'Product Maximum Rating', 'woopromotion' ),
				'options' => [
					'1' => '1',
					'1.5' => '1.5',
					'2' => '2',
					'2.5' => '2.5',
					'3' => '3',
					'3.5' => '3.5',
					'4' => '4',
					'4.5' => '4.5',
					'5' => '5'
				]
			),
			array(
				'type' 	=> 'select',
				'id' 	=> $this->prefix.'product_min_rating',
				'class' => 'product-min-rating',
				'label' => esc_html__( 'Product Minimum Rating', 'woopromotion' ),
				'options' => [
					'1' => '1',
					'1.5' => '1.5',
					'2' => '2',
					'2.5' => '2.5',
					'3' => '3',
					'3.5' => '3.5',
					'4' => '4',
					'4.5' => '4.5',
					'5' => '5'
				]
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'sold_min_limit',
				'class' => 'sold-min-limit',
				'label' => esc_html__( 'Minimum Sales', 'woopromotion' ),
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'less_stock',
				'class' => 'less-stock',
				'label' => esc_html__( 'Stock Less Than', 'woopromotion' ),
			),

		); // End meta field woopromotion_badges
		
		/**
		 *  Meta Field for coupon_code
		 *  
		 */

		// Init meta object
		$CouponCodeobj = $this->metabox_field_obj();

		// Meta Box Create
		$CouponCodeobj->SetMetaBox = array(
			'uniq_id' 	=> 'woopromotion_coupon_code_meta_field',
			'title' 	=> esc_html__( 'Coupon Code Settings', 'woopromotion'),
			'type' 		=> array( 'coupon_code' ),
			'context' =>  'normal',
			'priority' => 'high'
		);
		// Meta Fields
		$CouponCodeobj->SetMetaFields = array(
			array(
				'type' 	=> 'radio',
				'id' 	=> $this->prefix.'settings_type',
				'class' => 'settings-type',
				'label' => esc_html__( 'Settings Type', 'woopromotion' ),
				'default' => 'content',
				'options' => [
					'content' => esc_html__( 'Content', 'woopromotion' ),
					'style'   => esc_html__( 'Style', 'woopromotion' )
				]
			),
			// Content Settings
			array(
				'type' 	=> 'section_start',
				'id' 	=> $this->prefix.'content_settings_section_start',
				'class' => 'content-settings',
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'card_title',
				'class' => 'card-title',
				'label' => esc_html__( 'Card Title', 'woopromotion' ),
			),
			array(
				'type' 	=> 'textarea',
				'id' 	=> $this->prefix.'coupon_description',
				'class' => 'coupon-description',
				'label' => esc_html__( 'Description', 'woopromotion' ),
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'offer_value',
				'class' => 'offer-value',
				'label' => esc_html__( 'Offer Value', 'woopromotion' ),
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'offer_type',
				'class' => 'offer-type',
				'label' => esc_html__( 'Offer Type', 'woopromotion' ),
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'button',
				'class' => 'coupon-button',
				'label' => esc_html__( 'Button', 'woopromotion' ),
			),
			array(
				'type' 	=> 'text',
				'id' 	=> $this->prefix.'coupon_code',
				'class' => 'coupon-code',
				'label' => esc_html__( 'Coupon Code', 'woopromotion' ),
			),
			array(
				'type' 	=> 'section_end',
				'id' 	=> $this->prefix.'content_settings_section_end'
			), // End content section
			// Style
			array(
				'type' 	=> 'section_start',
				'id' 	=> $this->prefix.'style_settings_section_start',
				'class' => 'style-settings',
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'card_bg_color',
				'class' => 'title-color',
				'label' => esc_html__( 'Card Background Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'title_color',
				'class' => 'title-color',
				'label' => esc_html__( 'Title Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'discount_wrapper_bg_color',
				'class' => 'discount-wrapper-bg-color',
				'label' => esc_html__( 'Discount Wrapper Background Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'discount_text_color',
				'class' => 'discount-text-color',
				'label' => esc_html__( 'Discount Text Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'description_color',
				'class' => 'description-text-color',
				'label' => esc_html__( 'Description Text Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'button_area_bg_color',
				'class' => 'button-area-bg-color',
				'label' => esc_html__( 'Button Area Background Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'button_bg_color',
				'class' => 'button-bg-color',
				'label' => esc_html__( 'Button Background Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'button_text_color',
				'class' => 'button-text-color',
				'label' => esc_html__( 'Button Text Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'button_hover_bg_color',
				'class' => 'button-hover-bg-color',
				'label' => esc_html__( 'Button Hover Background Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'color',
				'id' 	=> $this->prefix.'button_hover_text_color',
				'class' => 'button-hover-text-color',
				'label' => esc_html__( 'Button Hover Text Color', 'woopromotion' ),
			),
			array(
				'type' 	=> 'section_end',
				'id' 	=> $this->prefix.'style_settings_section_end'
			) // End style section
		);

		// Init meta object for shortcode show
		$CouponCodeobj = $this->metabox_field_obj();

		// Meta Box Create
		$CouponCodeobj->SetMetaBox = array(
			'uniq_id' 	=> 'woopromotion_coupon_code_shortcode_meta_field',
			'title' 	=> esc_html__( 'Shortcode', 'woopromotion'),
			'type' 		=> array( 'coupon_code' ),
			'context' =>  'side',
			'priority' => 'high'
		);
		$CouponCodeobj->SetMetaFields = array(

			array(
				'type' 	=> 'show_shortcode',
				'id' 	=> $this->prefix.'show_shortcode',
				'class' => 'show-shortcode',
				'label' => esc_html__( 'Card Shortcode', 'woopromotion' ),
			),
		);

	} //


} // End Class