<?php 
namespace Woopromotion\Meta;
 /**
  * 
  * @package    WooPromotion
  * @version    1.0
  * @author     WPBucket
  * @Websites: http://wpbucket.net
  * 
  *
  */
 
  if( ! defined( 'ABSPATH' ) ) {
      die( WOOPROMOTION_ALERT_MSG );
  }


trait Checkbox {

  protected static $args;

  public function checkbox( $args ) {

    $default = [
      'title' => '',
      'name'  => '',
      'description' => '',
      'class'     => '',
      'condition'   => ''
    ];

    self::$args = wp_parse_args( $args, $default );

    self::checkbox_markup();
    
  }

  protected static function checkbox_markup() {

    $optionName = self::$optionName;
      $args = self::$args;
      $getData = self::$getOptionData;
      $fieldName  = $args['name'];
      $value = !empty( $getData[$fieldName] ) ? $getData[$fieldName] : '';

      $conditionData = '';
      if( !empty( $args['condition'] ) ) {
        $conditionData = json_encode( $args['condition'] );
      }
    ?>
    <div class="wpb-admin-field" data-condition="<?php echo esc_html($conditionData); ?>">
      <h4><?php echo esc_html( $args['title'] ); ?></h4>
      <div class="woopromo-field-group">
      <input type="checkbox" name="<?php echo esc_attr( $optionName ).'['.$fieldName.']'; ?>" value="yes" <?php checked( esc_html( $value ), 'yes'  ); ?>  />
      <?php 
      if( !empty( $args['description'] ) ) {
        echo '<p>'.esc_html( $args['description'] ).'</p>';
      }
      ?>
      </div>
    </div>
    <?php
  }
}