( function(  $ ) {

	"use stricts";

	// Color Picker
    $('.woopromo-color-input-field').wpColorPicker();

    // Woo Product add select 2
    if( $('.woopromotion-multiselect').length ) {
        $('.woopromotion-multiselect').selectWoo();
    }

	/**
	 * WP Media upload for meta
	 * 
	 **/

	// Set all variables to be used in scope
	
	var metaBox = $('.tatcmf-media');

	metaBox.each( function() {

		var $this = $( this );

		var frame,
		  addImgLink = $this.find('.upload-custom-img'),
		  delImgLink = $this.find( '.delete-custom-img'),
		  imgContainer = $this.find( '.custom-img-container'),
		  imgIdInput = $this.find( '.custom-img-id' );

		// ADD IMAGE LINK
		addImgLink.on( 'click', function( event ){

		event.preventDefault();

		// If the media frame already exists, reopen it.
		if ( frame ) {
		  frame.open();
		  return;
		}

		// Create a new media frame
		frame = wp.media({
			  title: 'Select or Upload Media Of Your Chosen Persuasion',
			  button: {
			    text: 'Use this media'
			  },
			  multiple: false  // Set to true to allow multiple files to be selected
		});


		// When an image is selected in the media frame...
		frame.on( 'select', function() {
		  
			  // Get media attachment details from the frame state
			  var attachment = frame.state().get('selection').first().toJSON();

			  // Send the attachment URL to our custom image input field.
			  imgContainer.append( '<img src="'+attachment.url+'" alt="" style="max-width:100%;"/>' );

			  // Send the attachment id to our hidden input
			  imgIdInput.val( attachment.id );

			  // Hide the add image link
			  addImgLink.addClass( 'hidden' );

			  // Unhide the remove image link
			  delImgLink.removeClass( 'hidden' );
			});

			// Finally, open the modal on click
			frame.open();
		});


		// DELETE IMAGE LINK
		delImgLink.on( 'click', function( event ){

			event.preventDefault();

			// Clear out the preview image
			imgContainer.html( '' );

			// Un-hide the add image link
			addImgLink.removeClass( 'hidden' );

			// Hide the delete image link
			delImgLink.addClass( 'hidden' );

			// Delete the image id from the hidden input
			imgIdInput.val( '' );

		});

	} );


	// Shortcode Copy
    $('.copy-shortcode').on( 'click', function() {
        var $shortcode = $(this).parent().children('.shortcodearea');

        var $temp = $("<input>");
        $("body").append($temp);
        $temp.val($shortcode.text()).select();
        document.execCommand("copy");
        $temp.remove();

        $(this).addClass('green-color');
        $(this).find('.copy-to').fadeIn().fadeOut('3000')
        
    } );

	// Content Tab Condation
    var typeTab = $( '[data-tab]' ),
    	contentFields = $( '.notification_content_tab' ),
    	styleFields   = $( '.notification_style_tab' );

    if( typeTab.data('tab') == 'style' ) {
    	styleFields.show();
    	contentFields.hide();
    }else {
    	contentFields.show();
    	styleFields.hide();
    }

    typeTab.on( 'click', function() {

    	var val = $( this ).data('tab');

    	if( val == 'style' ) {
    		styleFields.show();
    		contentFields.hide();
    	} else {
	    	contentFields.show();
	    	styleFields.hide();
    	}

    } )

	// Tab active 
	$('.single-tab').on( 'click', function() {

		$('.active').removeClass('active');
		$(this).addClass('active');

	} )

	// Time Picker
	$('.timepicker').mdtimepicker({
	  theme: 'purple'       
	});

	/**** conditional fields ****/

	let $tigger = $('[name="woopromotion_badge_type"]'),
		$productCategory 	= $('.product-category'),
		$minimumReviews 	= $('.minimum-reviews'),
		$productMaxRating 	= $('.product-max-rating'),
		$productMinRating 	= $('.product-min-rating'),
		$soldMinLimit 		= $('.sold-min-limit'),
		$lessStock			= $('.less-stock');



	// Default
	conditionalFieldsMap( $tigger.val() );
	//
	$tigger.on( 'change', function() {

		let $that = $(this);
		conditionalFieldsMap( $that.val() );

	} )


	function conditionalFieldsMap( $val ) {
		//
		$productCategory.hide();
		$minimumReviews.hide();
		$productMaxRating.hide();
		$productMinRating.hide();
		$soldMinLimit.hide();
		$lessStock.hide();


		// Category Field
		if( $val == 'category' ) {
			$productCategory.show();
		}
		// Rating Field
		if( $val == 'rating' ) {
			$minimumReviews.show();
			$productMinRating.show();
		}
		
		// Sales Field
		if( $val == 'sales' ) {
			$soldMinLimit.show();
		}
		// Stock Field
		if( $val == 'stock' ) {
			$lessStock.show();
		}
		// less stock Field
		if( $val == 'sales_rating' ) {
			$soldMinLimit.show();
			$minimumReviews.show();
			$productMinRating.show();
		}


	}

	/***********************************************
	 * 	Coupon Card content and style conditional
	************************************************/

	let $settingsType = $('.settings-type'),
		$contentSettings = $('.content-settings'),
		$styleSettings = $('.style-settings');

	//
	$settingsType.on( 'click', function() {

		let thisVal = $(this).val();

		if( thisVal == 'style' ) {
			$contentSettings.hide();
			$styleSettings.show();
		} else {
			$contentSettings.show();
			$styleSettings.hide();
		}

	} )

	// Default Check
	
	if( $settingsType.val() == 'content' ) {
		$contentSettings.show();
		$('.style-settings').hide();
	} else {
		$contentSettings.hide();
		$styleSettings.show();
	}


} )(jQuery);